#include "seg_ext.h"

int	DEBUG_Unit = 0;

/* 7/88 Matt Wilson */
Unit(unit,action)
register struct unit_type 	*unit;
Action				*action;
{
double				dv_dt;
double				dt;
MsgIn				*msg;

    if(Debug(DEBUG_Unit) > 1){
	printf("Unit '%s' action '%s'.\n",
	Pathname(unit),
	Actionname(action)
	);
    }
    switch(action->type){
    case PROCESS:
	dt = Clockrate(unit);
	/*
	** leakage component
	*/
	dv_dt = (unit->Em - unit->state)/unit->Rm  
		+ unit->inject + unit->activation;
	for(msg=unit->msg_in;msg;msg=msg->next){
	    switch(msg->type){
	    /*
	    ** type 0 : current injection
	    **     0 = Ik
	    */
	    case 0:
		dv_dt += MsgValue(msg,double,0);
		break;
	    }
	}
	dv_dt /= unit->Cm;
	/*
	** INTEGRATION
	*/
	unit->state = 
	DirectIntegrate(unit->method,unit,unit->state,dv_dt,dt,"Ustate");
	break;
    case INIT:
	unit->activation = 0;
	break;
    case RESET:
	unit->activation = 0;
	unit->state = unit->Em;
	break;
    case CHECK:
	if(unit->Cm <= 0.0){
	    ErrorMessage("Unit","Cm <= 0.",unit);
	}
	if(unit->Rm == 0.0){
	    ErrorMessage("Unit","Rm not set.",unit);
	}
	break;
    }
}
