/* 
** innergraph_w.h: inner graph widget includes & defines
**
** Written by:	Upinder S. Bhalla 	(bhalla@aurel.caltech.edu)
**		John Uhley 		(uhley@tybalt.caltech.edu)
**
** Copyright 1988 by the California Institute of Technology
**
** Permission to use, copy, modify, and distribute this
** software and its documentation for any purpose and without
** fee is hereby granted, provided that the above copyright
** notice appear in all copies and that both that copyright
** notice and this permission notice appear in supporting
** documentation, and that the name of the California Institute
** of Technology not be used in advertising or publicity pertaining 
** to distribution of the software without specific, written prior 
** permission.  The California Institute of Technology makes no 
** representations about the suitability of this software for any purpose.
** It is provided "as is" without express or implied warranty.
** 
** The Xgraph Widget library was written by Upinder S. Bhalla and
** John Uhley.  Portions of the labeling routines were taken from
** David Harrison's xgraph (X10V4) program with his permission.
**
** The X Window system is copyright 1985, 1986, 1987 By the
** Massachusetts Institute of Technology, without whom none of this
** code would have been possible.
**
*/
#ifndef _innergraph_w_h

#define	MIN_GRAPH_WIDTH	100
#define	MIN_GRAPH_HEIGHT 100

#define XOUT 0

#ifndef EPSILON
#define EPSILON 1.0e-60
#endif

#define XtNxmin		"xmin"
#define XtNymin		"ymin"
#define XtNxmax		"xmax"
#define XtNymax 	"ymax"

#define XtCGraphXmin	"GraphXmin"
#define XtCGraphYmin	"GraphYmin"
#define XtCGraphXmax	"GraphXmax"
#define XtCGraphYmax	"GraphYmax"

typedef struct _InnerGraphRec *InnerGraphWidget;
extern WidgetClass innergraphWidgetClass;

extern int output_flag;

#define  _innergraph_w_h
#endif _innergraph_w_h
